
' Revision 7 - 26/07/2004 

Option Explicit

Dim App As Object
Dim Part As Object
Dim Parts As Object
Dim Cmds As Object
Dim Cmd As Object
Dim Dcmd As Object
Dim Mypoint As Object
Dim Machine As Object

Dim sSelFea(100) As String
Dim iSelFea As Integer
Dim iOutFea As Integer
Dim sOutFea As String
Dim iAllFea As Integer
Dim iTPCount
Dim iTPSubCount


Sub Wait(ByVal T As Integer)
   Dim ts, te, elapsed As Integer
   ts=Timer
   te=Timer
    While elapsed < T
      te=Timer
      elapsed = te- ts
    Wend   
End Sub

Function InitPCD() As Boolean

    Dim AllPrg As Integer, i As Integer, onlinei As Integer
    Dim OnLineExists As Boolean
    Dim Response As Integer 
    Dim PNactive As String, PNonline As String

    InitPCD = True
    Set App = CreateObject("PCDLRN.Application")
    If App Is Nothing Then
        MsgBox "PC-DMIS initialisation error!",48, "Error"
        InitPCD = False
    Else

        Set Parts=App.PartPrograms
        AllPrg=Parts.count
        OnLineExists = False
        For i=1 To AllPrg
             Set Part = Parts.Item(i)
             Set Machine = Part.ActiveMachine
             If Machine.Name <> "OFFLINE" Then
                OnLineExists = True
                onlinei=i
                PNonline=Part.PartName
                Exit For
             End If
        Next i

        Set Part = App.ActivePartProgram
        If OnLineExists = True Then
           PNactive=Part.PartName
           If PNactive <> PNonline Then
               Response = Part.MessageBox( "The following program runs ON-LINE in background: " & chr(10) & chr(10) & PNonline & chr(10) & chr(10) &"Save statistic for this program?","EXPORTQS - ON-LINE Program running!", 4)
               If Response = PCDMSG_YES Then
                   Set Part = Parts.Item(onlinei)
               End If
           End If
        End If        

        If Part Is Nothing Then
            MsgBox "Part Program not opened!", 48, "Error"
            InitPCD = False
        Else
            Set Cmds = Part.Commands
            If Cmds Is Nothing Then
                MsgBox "Pointer to commands not valid!", 48, "Error"
                InitPCD = False
            End If
        End If
    End If
End Function

Function WriteHeader(Part As String, Drawing As String, Note As String, Producer As String, PartNo As String, Machine As String) As Integer
   Dim CNow
   Dim CDay As String
   Dim CMonth As String
   Dim CYear As String 
   Dim CHour As String
   Dim CMinute As String
   Dim CSecond As String

   ' This section is just used To simulate different delay And
   ' To make people think you'v changed the part...
   ' CNow=Now
   ' CSecond=Format(CNow,"ss")
   ' Wait(CInt(CSecond)+7)
 
   CNow=Now
   CDay=Format(CNow,"dd")
   CMonth=Format(CNow,"mm")
   CYear=Format(CNow,"yyyy")
   CHour=Format(CNow,"hh")
   CMinute=Format(CNow,"nn")
   CSecond=Format(CNow,"ss")

    Select Case CMonth
      Case "01"
         CMonth="JAN"
      Case "02"
         CMonth="FEB"
      Case "03"
         CMonth="MAR"
      Case "04"
         CMonth="APR"
      Case "05"
         CMonth="MAY"
      Case "06"
         CMonth="JUN"
      Case "07"
         CMonth="JUL"
      Case "08"
         CMonth="AUG"
      Case "09"
         CMonth="SEP"
      Case "10"
         CMonth="OCT"
      Case "11"
         CMonth="NOV"
      Case "12"
         CMonth="DEC"
    End Select

   
    Open "c:\\exportqs.q" For Output As #1
    Open "c:\\exportqs1.q" For Output As #2
    Print #1, Part
    Print #1, Drawing
    Print #1, Note
    Print #1, Producer
    Print #1, PartNo
    Print #1, Machine
    Print #1,CDay;"-",CMonth;"-",CYear 
    Print #1, CHour;":";CMinute;":",CSecond
    Print #1, "DEA Global"
    Print #1, "S/N"

    Print #2, Part
    Print #2, Drawing
    Print #2, Note
    Print #2, Producer
    Print #2, PartNo
    Print #2, Machine
    Print #2,CDay;"-",CMonth;"-",CYear 
    Print #2, CHour;":";CMinute;":",CSecond
    Print #2, "DEA Global"
    Print #2, "S/N"
    Close #1
    Close #2


    WriteHeader = 1    
End Function

Function RemoveB(ByVal Fname As String) As String
    Dim pos As Integer
    RemoveB = Fname
    pos=InStr(1,RemoveB,"[",1)             
    If pos <> 0 Then RemoveB = Left(RemoveB, pos-1)      
End Function


Function WriteValues(InvLT As String, ExePath As String, FeatNameS As String) As Integer
  Dim index As Integer, j As Integer
  Dim tot_com As Integer
  Dim FName As String, FNameOld As String
  Dim FType As String
  Dim MEA As Double 
  Dim UT As Double
  Dim LT As Double 
  Dim NOM As Double
  Dim BasPath As String
  Dim ScriptName As String
  Dim BasPathLen As Integer
  Dim Stringa As String 
  Dim iwTPCount As String 
  Dim iwTPSubCount  
  Dim bTPRead As Boolean
  Dim dTPTol As Double

  WriteValues = 0
  iTPCount=0
  iTPSubCount=0
  iwTPCount=0
  iwTPSubCount=0


  Open "c:\\exportqs.q" For Append As #1
  Open "c:\\exportqs1.q" For Append As #2
  index=1
  tot_com=Cmds.Count  
  For index=1 To tot_com 
     Set Cmd = Cmds.Item(index)
     ' This is To find the directory of scripts called
     If  Cmd.Type = "12346" Then
        BasPath = Cmd.GetText (FILE_NAME,1)
        BasPathLen=Len(BasPath)
        ScriptName=Right$(BasPath,12)        
        If ScriptName="EXPORTQS.BAS" Then
          ExePath=Left$(BasPath,BasPathLen-12)
         End If
     End If
     If Cmd.IsDimension Then
          If WriteValues <> 2 Then
              WriteValues = 1
          End If
          Set Cmd = Cmds.Item(index)          
          Set Dcmd = Cmd.DimensionCommand
          If len(Dcmd.ID) <> 0 Then
                Fname=Dcmd.ID
                ' This is For Single Line Dimension commands
                 If VerifySingleDim(Cmd.Type) Then
                      UT=Dcmd.Plus
                      LT=Dcmd.Minus
                      If InvLT = "Y" Then
                          LT=LT*(-1)
                      End If
                      NOM=Dcmd.NOMINAL
                      MEA=Dcmd.Measured
                      FType=Dcmd.AxisLetter
                      If UT<>0 Or LT<>0 Then
                          Fname = RemoveB(Fname)
                          If iSelFea = 0 Then
                                WriteValues = 2
                                iAllFea = iAllFea+1
                                If VerifyOut (MEA,NOM,UT,LT,Fname & " / " & Ftype)=False Then Print #2,"          , " ; Fname; ",             0, " ; FType;" , ";NOM  ; " , " ; UT ; " , "; LT ; " , "; MEA;",";"0";",";"0"
                                Print #1,"          , " ; Fname; ",             0, " ; FType;" , ";NOM  ; " , " ; UT ; " , "; LT ; " , "; MEA;",";"0";",";"0"
                          Else
                                If CheckFea(Fname)=True Then  
                                   WriteValues = 2
                                   iAllFea = iAllFea+1
                                   If VerifyOut (MEA,NOM,UT,LT,Fname & " / " & Ftype)=False Then Print #2,"          , " ; Fname; ",             0, " ; FType;" , ";NOM  ; " , " ; UT ; " , "; LT ; " , "; MEA;",";"0";",";"0"
                                   Print #1,"          , " ; Fname; ",             0, " ; FType;" , ";NOM  ; " , " ; UT ; " , "; LT ; " , "; MEA;",";"0";",";"0"
                                End If
                          End If
                      End If
               End If
          Else
               ' This is For Multiple Line Dimension commands
                UT=Dcmd.Plus
                LT=Dcmd.Minus
                If InvLT = "Y" Then
                    LT=LT*(-1)
                End If
                NOM=Dcmd.NOMINAL
                MEA=Dcmd.Measured
                FType=Dcmd.AxisLetter

                 Fname = RemoveB(Fname)

                If CheckFea(Fname)=False And iSelFea <> 0 Then GoTo 1450

                'This part is If a TP tolerance is found
                Select Case VerifyTPDimension(Cmd.Type)
                     Case 2
                          If Fname <> FnameOld Then
                              FnameOld=Fname
                              iTPCount=iTPCount+1
                              iTPSubCount=0
                              dTPTol=Dcmd.Plus
                              bTPRead=True
                          End If                                    
                          iwTPCount=iTPCount
                     Case 1
                          If Fname <> FnameOld And iTPSubCount<>0 Then
                                iTPSubCount=0
                          End If
                          If Fname <> FnameOld Then
                              FnameOld=Fname
                              iTPCount=iTPCount+1
                              bTPRead=False
                          End If                                                       
                          iwTPCount=iTPCount
                          iTPSubCount=iTPSubCount+1 
                          iwTPSubCount=iTPSubCount
                         If bTPRead=True Then
                              UT=dTPTol/2
                              LT=-dTPTol/2
                         Else
                             For j=1 To 5
                                  Set Cmd=Cmds.Item(index+j)
                                  Set Dcmd = Cmd.DimensionCommand
                                   If Dcmd.AxisLetter = "TP" Then
                                          UT=Dcmd.Plus/2
                                          LT=-Dcmd.Plus/2
                                          dTPTol=Dcmd.Plus
                                          bTPRead=True
                                          Exit For
                                   End If
                             Next j
                             Set Cmd=Cmds.Item(index)
                             Set Dcmd=Cmd.DimensionCommand
                         End If
                     Case  0
                            iwTPCount=0
                            iwTPSubCount=0
                            iTPSubCount=0
                            bTPRead=False
                 End Select               
                If FType="TP" Then
                        MEA=Dcmd.Deviation
                        iwTPSubCount=0                       
                End If



                If UT<>0 Or LT<>0 Then
                    If iSelFea = 0 Then
                          WriteValues = 2
                          iAllFea = iAllFea+1
                          If VerifyOut (MEA,NOM,UT,LT,Fname & " / " & Ftype)=False  Then   Print #2,"          , " ; Fname; ",             0, " ; FType;" , ";NOM  ; " , " ; UT ; " , "; LT ; " , "; MEA;",";iwTPCount;",";iwTPSubCount
                          Print #1,"          , " ; Fname; ",             0, " ; FType;" , ";NOM  ; " , " ; UT ; " , "; LT ; " , "; MEA;",";iwTPCount;",";iwTPSubCount
                      Else
                          If CheckFea(Fname)=True Then 
                             WriteValues = 2
                             iAllFea = iAllFea+1
                             If VerifyOut (MEA,NOM,UT,LT,Fname & " / " & Ftype)=False Then Print #2,"          , " ; Fname; ",             0, " ; FType;" , ";NOM  ; " , " ; UT ; " , "; LT ; " , "; MEA;",";iwTPCount;",";iwTPSubCount
                             Print #1,"          , " ; Fname; ",             0, " ; FType;" , ";NOM  ; " , " ; UT ; " , "; LT ; " , "; MEA;",";iwTPCount;",";iwTPSubCount
                          End If
                    End If
                End If
                1450:
          End If
       100:              
       End If
    Next index
    Close #2
    Close #1
End Function

Function VerifySingleDim(dimtype As Integer) As Boolean
    VerifySingleDim = True
    Select Case dimtype
        Case 1000
            VerifySingleDim = False
        Case 1200
            VerifySingleDim = False
     End Select    
End Function


Function VerifyTPDimension(ByVal dimtype As Integer) As Integer
    VerifyTPDimension = 0
    Select Case dimtype
        Case DIMENSION_TRUE_DIAM_LOCATION
            VerifyTPDimension = 2
        Case DIMENSION_TRUE_X_LOCATION
           VerifyTPDimension = 1
        Case DIMENSION_TRUE_Y_LOCATION
            VerifyTPDimension = 1
        Case DIMENSION_TRUE_Z_LOCATION
           VerifyTPDimension = 1
    End Select
End Function

Function SeparateFea (ByVal Stringa As String) As Integer
      Dim i As Integer, j As Integer
      Dim Stringa1 As String, Stringa2 As String
     
      
      For j = 1 To 100
        i=InStr(1, Stringa, ",")
        If i=0 Then
            sSelFea(j)=Stringa
            SeparateFea=j 
            Exit For
        End If
        Stringa1 = Left(Stringa, i - 1)
        Stringa2 = Right(Stringa, (Len(Stringa) - InStr(1, Stringa, ",")))
        Stringa = Stringa2
        sSelFea(j) = Stringa1
      Next j
End Function

Function VerifyOut(ByVal MeaVal As Double, ByVal NomVal As Double, ByVal UTVal As Double, ByVal LTVal As Double, Fname As String) As Boolean
    Dim USL As Double, LSL As Double
    Dim OutOfTol As Double

    If UTVal=0 And LTVal=0 Then Exit Sub

    USL=NomVal+UTVal
    LSL=NomVal+LTVAL

    OutOfTol=0    
    If (Abs(MeaVal)<LSL) Then OutOfTol=Abs(MeaVal)-LSL
    If (Abs(MeaVal)>USL) Then OutOfTol=Abs(MeaVal)-USL
    
    If OutOfTol<>0 Then
        VerifyOut=True
        iOutFea=iOutFea+1  
        If iOutFea < 20 Then
           sOutFea=sOutFea & chr$(10) & chr$(13) & Fname & " -> " & "fuori di: " & Format(OutOfTol,"###0.000")
        End If
    Else
        VerifyOut=False
    End If
End Function

Function CheckFea(Stringa As String) As Boolean
    Dim i As Integer
    
    CheckFea=False

    For i=1 To iSelFea
        If sSelFea(i)=Stringa Then 
            CheckFea=True
            Exit Sub
        End If       
    Next i
End Function

Sub ExportQS1 (ByVal Part As String,ByVal Drawing As String,ByVal Note As String, ByVal Producer As String,ByVal PartNo As String,ByVal Machine As String,ByVal InvLT As String,ByVal FileName As String,ByVal FeatNameS As String,ByVal Confirm As String, ByVal QStVer As String) 

    Dim ExePath As String
    Dim ExeLine As String
    Dim WriteValueResult As Integer
    Dim MyLen As Integer  
    Dim Response As Long
    Dim iShownOutFea

    InvLT = "Y"

    iTPCount=0
    iTPSubCount=0


    ' Verifica che il nome file sia dato
    If Len(FileName)=0 Then
            MsgBox "Nome file non specificato!" & chr$(10) & chr$(13) & chr$(10) & chr$(13) & "Inserire il nome file senza estensione sulla voce Numero 8 dello script!",48,"Nome file mancante!"
            Exit Sub
    End If


    ' Mettere i nomi dei elementi nell'elenco nomi selezionati (oppure settare contatore 0, che significa salvare tutto) 
    If len(FeatNames) >0 Then 
          iSelFea=SeparateFea(FeatNameS)
    Else
          iSelFea=0
    End If

    ' Preparare intestazione messaggio per quote fuori e verificare la variabile per la conferma salvataggio
    sOutFea="Alcune quote risultano fuori tolleranza!" & chr$(10) & chr$(13) & chr$(10)  & chr$(13) & "Salvare comunque tutte le quote?"  & chr$(10) & chr$(13) & " (YES salva tutto, con NO si salvano SOLO le quote In tolleranza, con CANCEL le misure non vengono salvate)" &  chr$(10) & chr$(13)
    iOutFea=0
    Confirm=ucase$(Confirm)
    If Len(Confirm)=0 Then Confirm="N"
    If Confirm <> "Y" Then Confirm="N"

    QStVer=ucase$(QStVer)
    If Len(QStVer)=0 Then QStVer="3.2"
    If QStVer <> "ME" Then QStVer="3.2"


    ' Salvare i dati In un file intermedio da poterlo usare con exportqs.exe
    InitPCD
    WriteHeader Part,Drawing,Note,Producer,PartNo,Machine
    WriteValueResult = WriteValues (InvLT, ExePath,FeatNameS)

    ' Confirmation For saving
    Set Part = App.ActivePartProgram
    Response=PCDMSG_YES
    If (Confirm="Y") And (iOutFea<>0) Then
               If iOutFea <20 Then iShownOutFea = iOutFea Else iShownOutFea=19
               sOutFea=sOutFea & chr$(10) & chr$(13) & chr$(10) & chr$(13) & "Numero totale quote: " & iAllFea & " / Numero quote fuori: " & iOutFea & " (Mostrate : " & iShownOutFea & ")"
               Response = Part.MessageBox (sOutFea,"Quote Fuori Tolleranza", 3)
               If Response = PCDMSG_CANCEL Then Exit Sub
    End If

    If WriteValueResult = 2 Then
              If Response=PCDMSG_YES Then  ExeLine=ExePath & "EXPORTQS.EXE" & " /dat=c:\\exportqs.q /qst="  & FileName  & " /csv=" & FileName & ".csv" & " /ver=" & QStVer & " /wrn=N" 
              If Response=PCDMSG_NO Then  ExeLine=ExePath & "EXPORTQS.EXE" & " /dat=c:\\exportqs1.q /qst="  & FileName  & " /csv=" & FileName & ".csv" & " /ver=" & QStVer & " /wrn=N"
              Wait 2
              Shell ExeLine, 6
     End If
     If WriteValueResult = 1 Then
              Response=Part.MessageBox  ("Nessun dato  stato salvato!" & chr$(10) & chr$(13) & chr$(10) & chr$(13) & "Nessuna dimensione ha tolleranza valida, o non ci sono delle dimensioni specificate!","Dati non salvati",0)
      End If
     If WriteValueResult = 0 Then
             Response=Part.MessageBox  ("Nessun dato  stato salvato!" & chr$(10) & chr$(13) & chr$(10) & chr$(13) & "Nessuna dimensione trovata nel part programma!","Dati non salvati",0)
      End If
End Sub

' This are the allowed calls from PC-DMIS!!!

Sub Main(Part As String, Drawing As String, Note As String, Producer As String, PartNo As String, Machine As String, InvLT As String, FileName As String, FeatNameS As String, Confirm As String,QStVer As String)
      ExportQS1 Part , Drawing, Note , Producer, PartNo, Machine , InvLT, FileName, FeatNameS, Confirm, QStVer
End Sub

Sub ExportQS(Part As String, Drawing As String, Note As String, Producer As String, PartNo As String, Machine As String, InvLT As String, FileName As String, FeatNameS As String, Confirm As String,QStVer As String)
      ExportQS1 Part , Drawing, Note , Producer, PartNo, Machine , InvLT, FileName, FeatNameS, Confirm, QStVer
End Sub
